## qsapecng 1.2.2

=== CMakeLists.txt ===
project( qsapecng )
cmake_minimum_required( VERSION 2.6 )

set(
  CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
  "${CMAKE_SOURCE_DIR}/cmake/Modules/"
)
set( CMAKE_BUILD_TYPE "Release" )

set( PROJECT_VERSION_MAJOR 1 )
set( PROJECT_VERSION_MINOR 2 )
set( PROJECT_VERSION_PATCH 2 )
set( PROJECT_VERSION_REVISION 1 )
set( PROJECT_VERSION
  ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH} )

set( PACKAGE_VERSION "${PROJECT_VERSION}" )
set( PACKAGE_NAME "QSapecNG" )
set( SETTINGS_ORGANIZATION "Unifi" )
set( SETTINGS_APPLICATION "${PACKAGE_NAME}" )
set( PROJECT_AUTHOR "Michele Caini" )
set( PROJECT_YEAR_COPYRIGHT "2009-2011" )
set( PROJECT_AUTHOR_EMAIL "michele.caini@gmail.com" )
set( PACKAGE_CHEF "${PROJECT_AUTHOR} <${PROJECT_AUTHOR_EMAIL}>" )

# Uninstall Target
configure_file("${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# add_definitions( -ansi -Wall -O0 -g )
add_definitions( -ansi -Wall -O2 )
add_definitions(
  -DPACKAGE_NAME="${PACKAGE_NAME}"
  -DPACKAGE_VERSION="${PACKAGE_VERSION}"
)
if(WIN32)
  add_definitions( -static )
endif(WIN32)

if(UNIX)
  set( UNIX_SYS TRUE )
endif(UNIX)

if(WIN32)
  set( WIN32_SYS TRUE )
endif(WIN32)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in src/config.h )

add_subdirectory( src )

# create the debian.tar.gz file with the debian subfolder
find_program(TAR_EXECUTABLE tar)
if( TAR_EXECUTABLE )
  add_custom_target(debian_tar
    ${TAR_EXECUTABLE} -cz --exclude=.svn -f "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE_NAME}-${PACKAGE_VERSION}-debian.tar.gz" "debian/"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMENT "Create the tarball with the debian subfolder only.")
else( TAR_EXECUTABLE )
  # TODO this code doesn't exclude the .svn subfolders, try to fix!!
  add_custom_target(debian_tar
    ${CMAKE_COMMAND} -E tar czf "${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE_NAME}-${PACKAGE_VERSION}-debian.tar.gz" "debian/"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMENT "Create the tarball with the debian subfolder only.")
endif( TAR_EXECUTABLE )
mark_as_advanced( TAR_EXECUTABLE )


#################################################################
##################                             ##################
##################            CPACK            ##################
##################                             ##################
#################################################################

if(INCLUDE_QT_DLL_IN_BIN_PACKAGE OR INCLUDE_QWT5_DLL_IN_BIN_PACKAGE OR NOT QT_CONFIG MATCHES "static")
	include( InstallRequiredSystemLibraries )
endif(INCLUDE_QT_DLL_IN_BIN_PACKAGE OR INCLUDE_QWT5_DLL_IN_BIN_PACKAGE OR NOT QT_CONFIG MATCHES "static")


set( CPACK_GENERATOR "TZ;TGZ;TBZ2" )

set( CPACK_SOURCE_PACKAGE_FILE_NAME "${PACKAGE_NAME}-${PACKAGE_VERSION}-source" )
set( CPACK_PACKAGE_FILE_NAME "${PACKAGE_NAME}-${PACKAGE_VERSION}" )
set( CPACK_PACKAGE_NAME "${PACKAGE_NAME}" )
set( CPACK_PACKAGE_VENDOR "${PACKAGE_CHEF}" )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "QSapecNG - Qt-based GUI for SapecNG" )
SET( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE" )
SET( CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README" )
set( CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}" )
set( CPACK_PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}" )
set( CPACK_PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}" )
set( CPACK_SOURCE_IGNORE_FILES
  .*~
  .*kdev*
  /CMakeFiles/
  /_CPack_Packages/
  /\\\\.svn/
  /\\\\.DS_Store
  /\\\\.Trashes/
  \\\\.cproject
  \\\\.project
  CMakeCache\\\\.txt
  build.*
  \\\\.settings
  .*\\\\.patch
  moc_qtbuttonpropertybrowser\\\\.cpp
  moc_qteditorfactory\\\\.cpp
  moc_qtgroupboxpropertybrowser\\\\.cpp
  moc_qtpropertybrowser\\\\.cpp
  moc_qtpropertybrowserutils_p\\\\.cpp
  moc_qtpropertymanager\\\\.cpp
  moc_qttreepropertybrowser\\\\.cpp
  moc_qtvariantproperty\\\\.cpp
  qteditorfactory\\\\.moc
  qtpropertymanager\\\\.moc
  qttreepropertybrowser\\\\.moc
  /\\\\.pc/
  "${CMAKE_SOURCE_DIR}/debian/"
)
set(
  CPACK_PACKAGE_INSTALL_DIRECTORY
  "${CPACK_PACKAGE_NAME}-${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
)
set(
  CPACK_INSTALL_CMAKE_PROJECTS
  ${CMAKE_CURRENT_BINARY_DIR};${PACKAGE_NAME};ALL;/
)


if(WIN32 AND NOT UNIX)

  set( CPACK_PACKAGE_EXECUTABLES "${OUTPUT_BIN_NAME}" "${OUTPUT_BIN_NAME}" )
  set( CPACK_NSIS_INSTALLED_ICON_NAME "${OUTPUT_BIN_FOLDER}\\\\${OUTPUT_BIN_NAME}.exe" )
  set( CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}" )
  set( CPACK_NSIS_CONTACT "${PACKAGE_CHEF}" )
  set( CPACK_NSIS_URL_INFO_ABOUT "http://qsapecng.sourceforge.net/" )
  set( CPACK_NSIS_MODIFY_PATH ON )
  set( CPACK_GENERATOR NSIS ZIP )
  set( CPACK_SOURCE_GENERATOR ZIP )
  set(
    CPACK_NSIS_MUI_ICON
    "${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng-ico.ico"
  )
  set(
    CPACK_NSIS_MUI_UNIICON
    "${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng-ico.ico"
  )
  
  # la variabile CPACK_PACKAGE_ICON vuole una bmp da 150x57 pixel
  # la variabile CPACK_NSIS_INSTALLER_MUI_ICON_CODE vuole una bmp da 164x314 pixel
  #set( CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng_nsis_header.bmp" )
  #set( CPACK_NSIS_INSTALLER_MUI_ICON_CODE "!define MUI_WELCOMEFINISHPAGE_BITMAP '${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng_nsis_welcome.bmp'" )
  
  # Codice per far creare il link sul desktop se l'utente lo seleziona durante
  # l'installazione da setup: CMake crea un checkbox che non funziona!!!
  set( CPACK_NSIS_DESKTOP_LINK_NAME "QSapecNG" )
  set( CPACK_NSIS_EXTRA_INSTALL_COMMANDS "StrCmp $INSTALL_DESKTOP '1' 0 nodesktoplink\nCreateShortcut '$desktop\\\\${CPACK_NSIS_DESKTOP_LINK_NAME}.lnk' '$instdir\\\\${OUTPUT_BIN_FOLDER}\\\\${OUTPUT_BIN_NAME}.exe'\nnodesktoplink:\n" )
  set( CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "StrCmp $INSTALL_DESKTOP '1' 0 nodesktoplink\nDelete '$desktop\\\\${CPACK_NSIS_DESKTOP_LINK_NAME}.lnk'\nnodesktoplink:\n" )

elseif(APPLE)

  set( CPACK_DMG_VOLUME_NAME "${CPACK_PACKAGE_NAME}_${PROJECT_VERSION}" ) # da testare
  set( CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}" )
  set( CPACK_GENERATOR DragNDrop )
  set( CPACK_SOURCE_GENERATOR TGZ ZIP )

else()

  set( CPACK_STRIP_FILES "usr/${OUTPUT_BIN_FOLDER}/${OUTPUT_BIN_NAME}" )
  set( CPACK_SOURCE_STRIP_FILES "" )

  set( CPACK_GENERATOR "${CPACK_GENERATOR};DEB" )
  set( CPACK_SOURCE_GENERATOR TBZ2 TGZ ZIP)
  set( CPACK_DEBIAN_PACKAGE_MAINTAINER "${PACKAGE_CHEF}" )
  set( CPACK_DEBIAN_PACKAGE_SECTION Electronics )
  set( CPACK_DEBIAN_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION}+sid" )
  set(
    CPACK_DEBIAN_PACKAGE_DEPENDS
     "libstdc++6 (>=4.3.2-1.1),
      libqt4-core (>=4.6),
      libqt4-gui (>=4.6),
      libqwt5-qt4 (>=5.0)"
  )

endif(WIN32 AND NOT UNIX)


include( CPack )

=== src/CMakeLists.txt ===
find_package( Boost 1.41.0 REQUIRED )
find_package( Qt4 COMPONENTS QtCore QtGui REQUIRED )
find_package( Qwt5 REQUIRED )


if(WIN32)
  set( QT_USE_QTMAIN 1 )
endif(WIN32)

include( ${QT_USE_FILE} )
add_definitions( ${QT_DEFINITIONS} )

include_directories(
  ${QT_INCLUDES}
  ${Qwt5_INCLUDE_DIR}
  ${Boost_INCLUDE_DIRS}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)


### PLATFORM SPECIFIC DATA ###
set(OUTPUT_BIN_FOLDER bin)
set(OUTPUT_BIN_FOLDER "${OUTPUT_BIN_FOLDER}" PARENT_SCOPE)
set(OUTPUT_BUNDLE_FOLDER "./")
set(OUTPUT_FRAMEWORKS_FOLDER Frameworks)
set(OUTPUT_RESOURCES_FOLDER_NAME Resources)
set(BUNDLE_ICON)

if(UNIX AND NOT WIN32 AND NOT APPLE)
  set(OUTPUT_BIN_NAME "qsapecng")
  set(OUTPUT_BIN_NAME "${OUTPUT_BIN_NAME}" PARENT_SCOPE)
  #set(OUTPUT_DOC_FOLDER "share/doc/${OUTPUT_BIN_NAME}")
elseif(APPLE)
  set(OUTPUT_BIN_NAME "QSapecNG")
  set(OUTPUT_BIN_NAME "${OUTPUT_BIN_NAME}" PARENT_SCOPE)
  set(OUTPUT_DOC_FOLDER "${OUTPUT_BIN_NAME}.app/Contents/${OUTPUT_RESOURCES_FOLDER_NAME}/doc")
  set(OUTPUT_RES_FOLDER "${OUTPUT_BIN_NAME}.app/Contents/${OUTPUT_RESOURCES_FOLDER_NAME}")
  set(OUTPUT_BUNDLE_NAME "QSapecNG")

  option(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE "Enable this option to include required external libraries into application Bundle (default ON)" ON)

  set(MACOSX_BUNDLE_ICON_FILE "qsapecng.icns")
  set(BUNDLE_ICON "gui/images/${MACOSX_BUNDLE_ICON_FILE}")
  set_source_files_properties("${CMAKE_CURRENT_SOURCE_DIR}/gui/images/${MACOSX_BUNDLE_ICON_FILE}" PROPERTIES MACOSX_PACKAGE_LOCATION "${OUTPUT_RESOURCES_FOLDER_NAME}")

  # This section is for Info.plist and ${lang}.lproj subfolders
  set(MACOSX_BUNDLE_DISPLAY_NAME "${OUTPUT_BUNDLE_NAME}")
  set(MACOSX_BUNDLE_NAME "${OUTPUT_BUNDLE_NAME}")
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION_MAJOR}-${PROJECT_VERSION_MINOR}-${PROJECT_VERSION_PATCH}")
  set(MACOSX_BUNDLE_COPYRIGHT "Copyright (C) ${PROJECT_YEAR_COPYRIGHT} ${PROJECT_AUTHOR}")
  set(MACOSX_BUNDLE_VERSION "${PROJECT_VERSION}")
  set(MACOSX_BUNDLE_DEVELOPMENT_REGION "it_IT")
  set(MACOSX_BUNDLE_EXECUTABLE "${OUTPUT_BIN_NAME}")
  set(MACOSX_BUNDLE_IDENTIFIER "net.sourceforge.qsapecng")
  set(MACOSX_BUNDLE_PACKAGE_TYPE "APPL")
  set(MACOSX_BUNDLE_ADDITIONAL "<key>LSHasLocalizedDisplayName</key>\n<string>1</string>") # TODO da ritestare
  configure_file("${PROJECT_SOURCE_DIR}/cmake/MacOSXBundle_Info.plist.in" "${CMAKE_CURRENT_BINARY_DIR}/Info.plist" @ONLY)

  # this section is to fixup the bundle after it has been created
  set(FIXUP_BUNDLE_PATH "${PROJECT_BINARY_DIR}/${OUTPUT_BIN_FOLDER}/${OUTPUT_BIN_NAME}.app")
  set(FIXUP_BUNDLE_LIBS "")
  set(FIXUP_BUNDLE_DIRS "${Qwt5_INCLUDE_DIR}/../lib")
  configure_file("${PROJECT_SOURCE_DIR}/cmake/MacOSXBundle_fixup_bundle.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/fixup_bundle.cmake" @ONLY)

  if(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE)
    add_custom_target(fixup_bundle ALL COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/fixup_bundle.cmake")
  else(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE)
    add_custom_target(fixup_bundle COMMAND "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/fixup_bundle.cmake")
    message(STATUS "You can execute 'make fixup_bundle' to manually fixup the created bundle before distributing it")
  endif(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE)
elseif(WIN32)
  # Lo metterei maiuscolo su Windows, però ci sono da cambiare alcuni
  # percorsi in altri file di CMake.
  set(OUTPUT_BIN_NAME "qsapecng")
  set(OUTPUT_BIN_NAME "${OUTPUT_BIN_NAME}" PARENT_SCOPE)
  #set(OUTPUT_DOC_FOLDER "doc")

  unset(QT_DLL_DIR CACHE)
  find_path(QT_DLL_DIR
    NAMES
      "QtCore${QT_VERSION_MAJOR}.dll"
      "QtGui${QT_VERSION_MAJOR}.dll"
    PATHS
      "${QT_BINARY_DIR}"
      "${QT_LIBRARY_DIR}"
      "${QT_LIBRARY_DIR}/../bin"
    DOC "path of the Qt DLL files to be included in the binary packages"
    NO_DEFAULT_PATH
  )

  unset(QWT5_DLL_DIR CACHE)
  find_path(QWT5_DLL_DIR
    NAMES "qwt5.dll"
    PATHS
      "${Qwt5_INCLUDE_DIR}/../lib"
      "${Qwt5_INCLUDE_DIR}/../bin"
    PATH_SUFFIXES lib bin
    ENV PATH
    DOC "path of the Qwt DLL files to be included in the binary packages"
  )

  if(NOT QT_DLL_DIR STREQUAL "QT_DLL_DIR-NOTFOUND" AND NOT QT_CONFIG MATCHES "static")
    option(INCLUDE_QT_DLL_IN_BIN_PACKAGE "Enable this option to include Qt DLL files in binary packages (default ON)" ON)
  else(NOT QT_DLL_DIR STREQUAL "QT_DLL_DIR-NOTFOUND" AND NOT QT_CONFIG MATCHES "static")
    unset(INCLUDE_QT_DLL_IN_BIN_PACKAGE CACHE)
    set(INCLUDE_QT_DLL_IN_BIN_PACKAGE OFF)
    mark_as_advanced(INCLUDE_QT_DLL_IN_BIN_PACKAGE)
    mark_as_advanced(QT_DLL_DIR)
  endif(NOT QT_DLL_DIR STREQUAL "QT_DLL_DIR-NOTFOUND" AND NOT QT_CONFIG MATCHES "static")

  if(NOT QWT5_DLL_DIR STREQUAL "QWT5_DLL_DIR-NOTFOUND")
    option(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE "Enable this option to include Qwt DLL files in binary packages (default ON)" ON)
  else(NOT QWT5_DLL_DIR STREQUAL "QWT5_DLL_DIR-NOTFOUND")
    unset(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE CACHE)
    set(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE OFF)
    mark_as_advanced(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE)
    mark_as_advanced(QWT5_DLL_DIR)
  endif(NOT QWT5_DLL_DIR STREQUAL "QWT5_DLL_DIR-NOTFOUND")
endif()

set(
  LIBS
  ${LIBS} 
  ${QT_LIBRARIES}
  ${Qwt5_Qt4_LIBRARY}
)

IF(WIN32)
  set(
    LIBS
    ${LIBS}
    Imm32.lib
    Winmm.lib
    ws2_32.lib
  )
ENDIF(WIN32)


set(
  qtpropertyeditor_SRCS
  gui/qtsolutions/qtpropertyeditor/qtpropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/qtpropertymanager.cpp
  gui/qtsolutions/qtpropertyeditor/qteditorfactory.cpp
  gui/qtsolutions/qtpropertyeditor/qtvariantproperty.cpp
  gui/qtsolutions/qtpropertyeditor/qttreepropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/qtbuttonpropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/qtgroupboxpropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/qtpropertybrowserutils.cpp
)

qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtpropertybrowser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qtpropertybrowser.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtpropertymanager.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qtpropertymanager.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qteditorfactory.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qteditorfactory.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtvariantproperty.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qtvariantproperty.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qttreepropertybrowser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qttreepropertybrowser.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtbuttonpropertybrowser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qtbuttonpropertybrowser.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtgroupboxpropertybrowser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qtgroupboxpropertybrowser.cpp
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtpropertymanager.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtpropertymanager.moc
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qteditorfactory.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qteditorfactory.moc
)
qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qttreepropertybrowser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qttreepropertybrowser.moc
)

set(
  qtpropertyeditor_HEADERS_ONLY_MOC
  gui/qtsolutions/qtpropertyeditor/moc_qtpropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/moc_qtpropertymanager.cpp
  gui/qtsolutions/qtpropertyeditor/moc_qteditorfactory.cpp
  gui/qtsolutions/qtpropertyeditor/moc_qtvariantproperty.cpp
  gui/qtsolutions/qtpropertyeditor/moc_qttreepropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/moc_qtbuttonpropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/moc_qtgroupboxpropertybrowser.cpp
  gui/qtsolutions/qtpropertyeditor/qtpropertymanager.moc
  gui/qtsolutions/qtpropertyeditor/qteditorfactory.moc
  gui/qtsolutions/qtpropertyeditor/qttreepropertybrowser.moc
)

set_source_files_properties(
  ${qtpropertyeditor_HEADERS_ONLY_MOC}
  PROPERTIES
    HEADER_FILE_ONLY true
)

qt4_generate_moc(
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/qtpropertybrowserutils_p.h
  ${CMAKE_CURRENT_SOURCE_DIR}/gui/qtsolutions/qtpropertyeditor/moc_qtpropertybrowserutils_p.cpp
)

set(
  qtpropertyeditor_HEADERS_MOC
  gui/qtsolutions/qtpropertyeditor/moc_qtpropertybrowserutils_p.cpp
)

set(
  qtpropertyeditor_MOC
  ${qtpropertyeditor_HEADERS_MOC}
  ${qtpropertyeditor_HEADERS_ONLY_MOC}
)

qt4_add_resources(
  qtpropertyeditor_RESOURCES
  gui/qtsolutions/qtpropertyeditor/qtpropertybrowser.qrc
)

set(
  qsapecng_SRCS
  logger/logger.cpp
  model/circuit.cpp
  model/metacircuit.cpp
  parser/ir_circuit.cpp
  parser/crc_circuit.cpp
  functor/rpoly-adapter.cpp
  functor/rpoly.cpp
  gui/qsapecng.cpp
  gui/settings.cpp
  gui/qsapecngwindow.cpp
  gui/userdefdialog/userdefdialog.cpp
  gui/configdialog/configdialog.cpp
  gui/configdialog/configpage.cpp
  gui/sidebarmodel.cpp
  gui/sidebarview.cpp
  gui/delegate.cpp
  gui/editor/schematiceditor.cpp
  gui/editor/undoredocommand.cpp
  gui/editor/schematicsceneparser.cpp
  gui/editor/schematicscene.cpp
  gui/editor/graphicsnode.cpp
  gui/editor/component.cpp
  gui/editor/label.cpp
  gui/editor/wire.cpp
  gui/editor/item.cpp
  gui/workplane/workplane.cpp
)

set(
  qsapecng_HEADERS_MOC
  gui/qsapecngwindow.h
  gui/extendedmdiarea.h
  gui/userdefdialog/userdefdialog.h
  gui/configdialog/configdialog.h
  gui/configdialog/configpage.h
  gui/sidebarmodel.h
  gui/sidebarview.h
  gui/delegate.h
  gui/qlogger.h
  gui/editor/schematiceditor.h
  gui/editor/propertytextitem.hpp
  gui/editor/metacircuit_thread.hpp
  gui/editor/schematicscene.h
  gui/editor/schematicview.h
  gui/workplane/workplane.h
)

qt4_wrap_cpp( qsapecng_MOC ${qsapecng_HEADERS_MOC} )

qt4_add_resources(
  qsapecng_RESOURCES
  gui/qsapecng.qrc
)


set( CMAKE_RUNTIME_OUTPUT_DIRECTORY "../${OUTPUT_BIN_FOLDER}" )

add_executable(
  qsapecng WIN32 MACOSX_BUNDLE
  gui/qsapecng.rc
  ${qsapecng_MOC}
  ${qsapecng_SRCS}
  ${qsapecng_RESOURCES}
  ${qtpropertyeditor_MOC}
  ${qtpropertyeditor_SRCS}
  ${qtpropertyeditor_RESOURCES}
  "${BUNDLE_ICON}"
)

target_link_libraries( qsapecng ${LIBS} )

set_target_properties(qsapecng
  PROPERTIES
    MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_BINARY_DIR}/Info.plist"
    OUTPUT_NAME "${OUTPUT_BIN_NAME}"
)

install(
  TARGETS qsapecng
  RUNTIME DESTINATION "${OUTPUT_BIN_FOLDER}"
  BUNDLE DESTINATION "${OUTPUT_BUNDLE_FOLDER}"
)

if(UNIX AND NOT APPLE AND NOT WIN32)
  install(
    FILES gui/images/qsapecng.desktop
    DESTINATION share/applications
  )
  install(
    FILES gui/images/qsapecng-16x16.png
    DESTINATION share/icons/hicolor/16x16/apps
    RENAME qsapecng.png
  )
  install(
    FILES gui/images/qsapecng-32x32.png
    DESTINATION share/icons/hicolor/32x32/apps
    RENAME qsapecng.png
  )
  install(
    FILES gui/images/qsapecng-64x64.png
    DESTINATION share/icons/hicolor/64x64/apps
    RENAME qsapecng.png
  )
  install(
    FILES gui/images/qsapecng-128x128.png
    DESTINATION share/icons/hicolor/128x128/apps
    RENAME qsapecng.png
  )
  install(
    FILES gui/images/qsapecng-256x256.png
    DESTINATION share/icons/hicolor/256x256/apps
    RENAME qsapecng.png
  )
  install(
    FILES gui/images/qsapecng.svg
    DESTINATION share/icons/hicolor/scalable/apps
  )
endif(UNIX AND NOT APPLE AND NOT WIN32)

if(WIN32)
  if(INCLUDE_QT_DLL_IN_BIN_PACKAGE)
    install(
      FILES

=== debian/changelog ===
qsapecng (1.2.2-1) unstable; urgency=low

  * Initial release. (Closes: #609218)
  * Added a notice to the file src/functor/rpoly.cpp in order to release that
    file under a Public Domain-like license. The permission has been granted
    with an e-mail sent by the author of rpoly.cpp. See the file README.rpoly
    for more information.

 -- Simone Rossetto <simros85@gmail.com>  Sat, 02 Apr 2011 11:09:17 +0200

=== debian/control ===
Source: qsapecng
Section: electronics
Priority: optional
Maintainer: Simone Rossetto <simros85@gmail.com>
Uploaders: Georges Khaznadar <georgesk@ofset.org>
Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6.0), libqt4-dev (>= 4.6.0), libqwt5-qt4-dev (>= 5.2.0), libboost-dev (>= 1.41.0), doxygen
Standards-Version: 3.9.1
Homepage: http://qsapecng.sourceforge.net/
Vcs-Svn: https://qsapecng.svn.sourceforge.net/svnroot/qsapecng/trunk
Vcs-Browser: http://qsapecng.svn.sourceforge.net/viewvc/qsapecng/trunk

Package: qsapecng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: qsapecng-doc (= ${binary:Version})
Description: A Qt-based program for symbolic analysis of linear analog circuits.
 This program consists of two indipendent parts: the SapecNG framework engine
 and the GUI application QSapecNG.
 .
 QSapecNG is an open source, multi-platform project, continuously enhanced by
 students and researchers of the Department of Electronics and
 Telecommunications (DET) of the University of Florence (Italy). It comes as
 continuation of SapWin for Windows, in order to give to the project a full
 compatibility on other platforms.
 .
 Through SapecNG/QSapecNG users can draw, solve and analyze analog circuits as
 well as manage them.
 .
 SapecNG/QSapecNG is freely available on SourceForge.net
 <https://sourceforge.net/projects/qsapecng/>. A previous version of SapecNG is
 available too, on SourceForge.net <https://sourceforge.net/projects/sapec-ng/>.

Package: qsapecng-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: qsapecng (= ${binary:Version})
Suggests: doc-base
Description: Documentation for QSapecNG program.
 With QSapecNG users can draw, solve and analyze analog circuits as well as
 manage them.
 .
 This package contains the documentation of QSapecNG, that can also be read
 online at <http://qsapecng.sourceforge.net/>.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DH_ALWAYS_EXCLUDE=.svn
export DH_OPTIONS


%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release
	doxygen doxy.cfg

override_dh_auto_clean:
	dh_auto_clean
	rm -dfr doc/html doc/latex

## qsapecng 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,9 @@
 )
 set( CMAKE_BUILD_TYPE "Release" )
 
-set( PROJECT_VERSION_MAJOR 1 )
-set( PROJECT_VERSION_MINOR 2 )
-set( PROJECT_VERSION_PATCH 2 )
+set( PROJECT_VERSION_MAJOR 2 )
+set( PROJECT_VERSION_MINOR 0 )
+set( PROJECT_VERSION_PATCH 0 )
 set( PROJECT_VERSION_REVISION 1 )
 set( PROJECT_VERSION
   ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH} )
@@ -27,8 +27,8 @@
 configure_file("${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
 add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
-# add_definitions( -ansi -Wall -O0 -g )
-add_definitions( -ansi -Wall -O2 )
+add_definitions( -ansi -Wall -O0 -g )
+# add_definitions( -ansi -Wall -O2 )
 add_definitions(
   -DPACKAGE_NAME="${PACKAGE_NAME}"
   -DPACKAGE_VERSION="${PACKAGE_VERSION}"

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -243,7 +243,6 @@
   gui/qsapecng.cpp
   gui/settings.cpp
   gui/qsapecngwindow.cpp
-  gui/userdefdialog/userdefdialog.cpp
   gui/configdialog/configdialog.cpp
   gui/configdialog/configpage.cpp
   gui/sidebarmodel.cpp
@@ -265,7 +264,6 @@
   qsapecng_HEADERS_MOC
   gui/qsapecngwindow.h
   gui/extendedmdiarea.h
-  gui/userdefdialog/userdefdialog.h
   gui/configdialog/configdialog.h
   gui/configdialog/configpage.h
   gui/sidebarmodel.h
@@ -327,11 +325,21 @@
     RENAME qsapecng.png
   )
   install(
+    FILES gui/images/qsapecng-24x24.png
+    DESTINATION share/icons/hicolor/24x24/apps
+    RENAME qsapecng.png
+  )
+  install(
     FILES gui/images/qsapecng-32x32.png
     DESTINATION share/icons/hicolor/32x32/apps
     RENAME qsapecng.png
   )
   install(
+    FILES gui/images/qsapecng-48x48.png
+    DESTINATION share/icons/hicolor/48x48/apps
+    RENAME qsapecng.png
+  )
+  install(
     FILES gui/images/qsapecng-64x64.png
     DESTINATION share/icons/hicolor/64x64/apps
     RENAME qsapecng.png
@@ -347,12 +355,3 @@
     RENAME qsapecng.png
   )
   install(
-    FILES gui/images/qsapecng.svg
-    DESTINATION share/icons/hicolor/scalable/apps
-  )
-endif(UNIX AND NOT APPLE AND NOT WIN32)
-
-if(WIN32)
-  if(INCLUDE_QT_DLL_IN_BIN_PACKAGE)
-    install(
-      FILES

=== debian/changelog ===
qsapecng (2.0.0-5) unstable; urgency=low

  * Fixed "ftbfs with GCC-4.7" adding a "this" pointer. (Closes: #667342)
  * Updated the debian/copyright file:
     - converted the Comment field of the public-domain license for the file
       rpoly.cpp to the paragraph of the license itself (this fixes the the
       lintian warning missing-license-paragraph-in-dep5-copyright).
     - changed the Format url from dep5 to 1.0.
  * Updated debian/control Standards-Version to 3.9.3.

 -- Simone Rossetto <simros85@gmail.com>  Thu, 05 Apr 2012 20:11:49 +0200

qsapecng (2.0.0-4) unstable; urgency=low

  * added a DM-Upload-Allowed: yes field in debian/control

 -- Georges Khaznadar <georgesk@ofset.org>  Sun, 06 Nov 2011 21:01:32 +0100

qsapecng (2.0.0-3) unstable; urgency=low

  * fixed a typo in debian/rules "rm -dfr" => "rm -fr".
    Closes: #642675
  * added a set of files to clean, probably due to some mistake in upstream
    clean routines; added a clean instruction for src/libqwt6_fix.h

 -- Georges Khaznadar <georgesk@ofset.org>  Mon, 26 Sep 2011 07:35:42 +0200

qsapecng (2.0.0-2) unstable; urgency=low

  * Fixed "FTBFS: obsolete build dependency libqwt5-qt4-dev". Removed from
    debian/control obsolete libqwt5-qt4-dev dependency. (Closes: #638365)
  * Fixed the lintian warning "embedded-javascript-library" due to the file
    jquery.js previously included in the qsapecng-doc package. That file has
    been substituted with a symlink to the file installed with the package
    libjs-jquery.
  * Added libjs-jquery as a dependency for the qsapecng-doc package.

 -- Simone Rossetto <simros85@gmail.com>  Sat, 20 Aug 2011 19:59:06 +0200

qsapecng (2.0.0-1) unstable; urgency=low

  * New upstream release.
  * Updated debian/control:
     - changed Standards-Version to 3.9.2.
     - changed Build-Depends for Qwt libraries: libqwt5-qt4-dev | libqwt-dev.
     - changed Description to reflect the original one in the upstream README.
  * Removed unneeded compile flags (compile_flags.patch): debug symbols were
    always added to the final binaries even in the 'Release' target.
  * Solved incompatibility with Qwt version 6 (libqwt6_fix.patch).

 -- Simone Rossetto <simros85@gmail.com>  Thu, 11 Aug 2011 21:15:50 +0200

=== debian/control ===
Source: qsapecng
Section: electronics
Priority: optional
Maintainer: Simone Rossetto <simros85@gmail.com>
Uploaders: Georges Khaznadar <georgesk@ofset.org>
DM-Upload-Allowed: yes
Build-Depends:
 debhelper (>= 7.0.50~),
 cmake (>= 2.6.0),
 libqt4-dev (>= 4.6.0),
 libqwt-dev (>= 6.0.0),
 libboost-dev (>= 1.41.0),
 doxygen
Standards-Version: 3.9.3
Homepage: http://qsapecng.sourceforge.net/
Vcs-Svn: https://qsapecng.svn.sourceforge.net/svnroot/qsapecng
Vcs-Browser: http://qsapecng.svn.sourceforge.net/viewvc/qsapecng

Package: qsapecng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: qsapecng-doc (= ${binary:Version})
Description: symbolic analyzer and solver of linear analog circuits
 This program consists of two indipendent parts: the SapecNG framework engine
 and the GUI application QSapecNG.
 .
 QSapecNG is an open source, multi-platform project, continuously enhanced by
 students and researchers of the Department of Electronics and
 Telecommunications (DET) of the University of Florence (Italy). It comes as
 continuation of SapWin for Windows, in order to give to the project a full
 compatibility on other platforms.
 .
 Through SapecNG/QSapecNG users can draw, solve and analyze analog circuits as
 well as manage them. Since version 2.0.0beta1 there is also the full support
 for sub-circuits that can be created, saved, reopened and added as part of
 other circuits.
 .
 SapecNG/QSapecNG is freely available on SourceForge.net
 <https://sourceforge.net/projects/qsapecng/>. A previous version of SapecNG is
 available too, on SourceForge.net <https://sourceforge.net/projects/sapec-ng/>.

Package: qsapecng-doc
Architecture: all
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Recommends: qsapecng (= ${binary:Version})
Suggests: doc-base
Description: symbolic analyzer and solver of linear analog circuits (documentation)
 With QSapecNG users can draw, solve and analyze analog circuits as well as
 manage them. Since version 2.0.0beta1 there is also the full support
 for sub-circuits that can be created, saved, reopened and added as part of
 other circuits.
 .
 This package contains the documentation of QSapecNG, that can also be read
 online at <http://qsapecng.sourceforge.net/>.

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,12 @@
 		-DCMAKE_INSTALL_PREFIX=/usr \
 		-DCMAKE_BUILD_TYPE=Release
 	doxygen doxy.cfg
+	rm -f doc/html/jquery.js
+	ln -s /usr/share/javascript/jquery/jquery.js doc/html/jquery.js
 
 override_dh_auto_clean:
 	dh_auto_clean
-	rm -dfr doc/html doc/latex
+	rm -fr doc/html doc/latex
+	rm -f src/gui/qtsolutions/qtpropertyeditor/moc_*
+	rm -f src/gui/qtsolutions/qtpropertyeditor/*.moc
+	rm -f src/libqwt6_fix.h

=== debian/watch ===
version=3
http://sf.net/qsapecng/QSapecNG-(.*)-source\.tar\.gz

## qsapecng 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,29 @@
 project( qsapecng )
-cmake_minimum_required( VERSION 2.6 )
+cmake_minimum_required( VERSION 2.8 )
+
+# qtcreator lacks a proper file management for software based on cmake,
+# this is a workaround to include file within the project tree.
+# see also add_executable statement.
+file(GLOB_RECURSE FILES src/*.h src/*.hpp src/*.cpp)
+file(GLOB_RECURSE DOXY doxy.cfg doxy/*.dox)
 
 set(
   CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
   "${CMAKE_SOURCE_DIR}/cmake/Modules/"
 )
-set( CMAKE_BUILD_TYPE "Release" )
+
+if(NOT CMAKE_BUILD_TYPE)
+  set(CMAKE_BUILD_TYPE "Release")
+endif(NOT CMAKE_BUILD_TYPE)
+
+if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
+  add_definitions(-DQT_NO_DEBUG_OUTPUT)
+endif(NOT CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
 
 set( PROJECT_VERSION_MAJOR 2 )
-set( PROJECT_VERSION_MINOR 0 )
-set( PROJECT_VERSION_PATCH 0 )
-set( PROJECT_VERSION_REVISION 1 )
+set( PROJECT_VERSION_MINOR 1 )
+set( PROJECT_VERSION_PATCH 1 )
+set( PROJECT_VERSION_REVISION 0 )
 set( PROJECT_VERSION
   ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH} )
 
@@ -19,7 +32,7 @@
 set( SETTINGS_ORGANIZATION "Unifi" )
 set( SETTINGS_APPLICATION "${PACKAGE_NAME}" )
 set( PROJECT_AUTHOR "Michele Caini" )
-set( PROJECT_YEAR_COPYRIGHT "2009-2011" )
+set( PROJECT_YEAR_COPYRIGHT "2009" )
 set( PROJECT_AUTHOR_EMAIL "michele.caini@gmail.com" )
 set( PACKAGE_CHEF "${PROJECT_AUTHOR} <${PROJECT_AUTHOR_EMAIL}>" )
 
@@ -27,8 +40,7 @@
 configure_file("${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
 add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
-add_definitions( -ansi -Wall -O0 -g )
-# add_definitions( -ansi -Wall -O2 )
+add_definitions( -ansi -Wall )
 add_definitions(
   -DPACKAGE_NAME="${PACKAGE_NAME}"
   -DPACKAGE_VERSION="${PACKAGE_VERSION}"
@@ -72,9 +84,9 @@
 ##################                             ##################
 #################################################################
 
-if(INCLUDE_QT_DLL_IN_BIN_PACKAGE OR INCLUDE_QWT5_DLL_IN_BIN_PACKAGE OR NOT QT_CONFIG MATCHES "static")
+if(INCLUDE_QT_DLL_IN_BIN_PACKAGE OR INCLUDE_QWT_DLL_IN_BIN_PACKAGE OR NOT QT_CONFIG MATCHES "static")
 	include( InstallRequiredSystemLibraries )
-endif(INCLUDE_QT_DLL_IN_BIN_PACKAGE OR INCLUDE_QWT5_DLL_IN_BIN_PACKAGE OR NOT QT_CONFIG MATCHES "static")
+endif(INCLUDE_QT_DLL_IN_BIN_PACKAGE OR INCLUDE_QWT_DLL_IN_BIN_PACKAGE OR NOT QT_CONFIG MATCHES "static")
 
 
 set( CPACK_GENERATOR "TZ;TGZ;TBZ2" )
@@ -131,7 +143,7 @@
 
   set( CPACK_PACKAGE_EXECUTABLES "${OUTPUT_BIN_NAME}" "${OUTPUT_BIN_NAME}" )
   set( CPACK_NSIS_INSTALLED_ICON_NAME "${OUTPUT_BIN_FOLDER}\\\\${OUTPUT_BIN_NAME}.exe" )
-  set( CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}" )
+  set( CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_NAME}" )
   set( CPACK_NSIS_CONTACT "${PACKAGE_CHEF}" )
   set( CPACK_NSIS_URL_INFO_ABOUT "http://qsapecng.sourceforge.net/" )
   set( CPACK_NSIS_MODIFY_PATH ON )
@@ -146,20 +158,20 @@
     "${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng-ico.ico"
   )
   
-  # la variabile CPACK_PACKAGE_ICON vuole una bmp da 150x57 pixel
-  # la variabile CPACK_NSIS_INSTALLER_MUI_ICON_CODE vuole una bmp da 164x314 pixel
+  # the variable CPACK_PACKAGE_ICON require a bmp file of 150x57 pixels
+  # the variable CPACK_NSIS_INSTALLER_MUI_ICON_CODE equire a bmp file of 164x314 pixels
   #set( CPACK_PACKAGE_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng_nsis_header.bmp" )
   #set( CPACK_NSIS_INSTALLER_MUI_ICON_CODE "!define MUI_WELCOMEFINISHPAGE_BITMAP '${CMAKE_CURRENT_SOURCE_DIR}\\\\src\\\\gui\\\\images\\\\qsapecng_nsis_welcome.bmp'" )
   
-  # Codice per far creare il link sul desktop se l'utente lo seleziona durante
-  # l'installazione da setup: CMake crea un checkbox che non funziona!!!
-  set( CPACK_NSIS_DESKTOP_LINK_NAME "QSapecNG" )
+  # Code to create the link on Windows Desktop if the user checks the appropriate box
+  # during setup: CMake creates a checkbox that doesn't work!!!
+  set( CPACK_NSIS_DESKTOP_LINK_NAME "${OUTPUT_BIN_NAME}" )
   set( CPACK_NSIS_EXTRA_INSTALL_COMMANDS "StrCmp $INSTALL_DESKTOP '1' 0 nodesktoplink\nCreateShortcut '$desktop\\\\${CPACK_NSIS_DESKTOP_LINK_NAME}.lnk' '$instdir\\\\${OUTPUT_BIN_FOLDER}\\\\${OUTPUT_BIN_NAME}.exe'\nnodesktoplink:\n" )
   set( CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "StrCmp $INSTALL_DESKTOP '1' 0 nodesktoplink\nDelete '$desktop\\\\${CPACK_NSIS_DESKTOP_LINK_NAME}.lnk'\nnodesktoplink:\n" )
 
 elseif(APPLE)
 
-  set( CPACK_DMG_VOLUME_NAME "${CPACK_PACKAGE_NAME}_${PROJECT_VERSION}" ) # da testare
+  set( CPACK_DMG_VOLUME_NAME "${CPACK_PACKAGE_NAME}_${PROJECT_VERSION}" ) # to be tested
   set( CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}" )
   set( CPACK_GENERATOR DragNDrop )
   set( CPACK_SOURCE_GENERATOR TGZ ZIP )
@@ -179,10 +191,9 @@
      "libstdc++6 (>=4.3.2-1.1),
       libqt4-core (>=4.6),
       libqt4-gui (>=4.6),
-      libqwt5-qt4 (>=5.0)"
+      libqwt6-qt4 (>=6.0)"
   )
 
 endif(WIN32 AND NOT UNIX)
 
-
 include( CPack )

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-find_package( Boost 1.41.0 REQUIRED )
-find_package( Qt4 COMPONENTS QtCore QtGui REQUIRED )
-find_package( Qwt5 REQUIRED )
+find_package( Boost 1.46.0 REQUIRED )
+find_package( Qt4 4.6.2 COMPONENTS QtCore QtGui REQUIRED )
+find_package( Qwt 6.0.0 REQUIRED )
 
 
 if(WIN32)
@@ -12,7 +12,7 @@
 
 include_directories(
   ${QT_INCLUDES}
-  ${Qwt5_INCLUDE_DIR}
+  ${QWT_INCLUDE_DIRS}
   ${Boost_INCLUDE_DIRS}
   ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR}
@@ -36,7 +36,7 @@
   set(OUTPUT_BIN_NAME "${OUTPUT_BIN_NAME}" PARENT_SCOPE)
   set(OUTPUT_DOC_FOLDER "${OUTPUT_BIN_NAME}.app/Contents/${OUTPUT_RESOURCES_FOLDER_NAME}/doc")
   set(OUTPUT_RES_FOLDER "${OUTPUT_BIN_NAME}.app/Contents/${OUTPUT_RESOURCES_FOLDER_NAME}")
-  set(OUTPUT_BUNDLE_NAME "QSapecNG")
+  set(OUTPUT_BUNDLE_NAME "${OUTPUT_BIN_NAME}")
 
   option(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE "Enable this option to include required external libraries into application Bundle (default ON)" ON)
 
@@ -60,7 +60,7 @@
   # this section is to fixup the bundle after it has been created
   set(FIXUP_BUNDLE_PATH "${PROJECT_BINARY_DIR}/${OUTPUT_BIN_FOLDER}/${OUTPUT_BIN_NAME}.app")
   set(FIXUP_BUNDLE_LIBS "")
-  set(FIXUP_BUNDLE_DIRS "${Qwt5_INCLUDE_DIR}/../lib")
+  set(FIXUP_BUNDLE_DIRS "${QWT_ROOT_DIR}/lib")
   configure_file("${PROJECT_SOURCE_DIR}/cmake/MacOSXBundle_fixup_bundle.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/fixup_bundle.cmake" @ONLY)
 
   if(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE)
@@ -70,9 +70,7 @@
     message(STATUS "You can execute 'make fixup_bundle' to manually fixup the created bundle before distributing it")
   endif(INCLUDE_REQUIRED_LIBRARIES_INTO_BUNDLE)
 elseif(WIN32)
-  # Lo metterei maiuscolo su Windows, però ci sono da cambiare alcuni
-  # percorsi in altri file di CMake.
-  set(OUTPUT_BIN_NAME "qsapecng")
+  set(OUTPUT_BIN_NAME "QSapecNG")
   set(OUTPUT_BIN_NAME "${OUTPUT_BIN_NAME}" PARENT_SCOPE)
   #set(OUTPUT_DOC_FOLDER "doc")
 
@@ -89,12 +87,12 @@
     NO_DEFAULT_PATH
   )
 
-  unset(QWT5_DLL_DIR CACHE)
-  find_path(QWT5_DLL_DIR
-    NAMES "qwt5.dll"
+  unset(QWT_DLL_DIR CACHE)
+  find_path(QWT_DLL_DIR
+    NAMES "qwt.dll"
     PATHS
-      "${Qwt5_INCLUDE_DIR}/../lib"
-      "${Qwt5_INCLUDE_DIR}/../bin"
+      "${QWT_INCLUDE_DIR}/../lib"
+      "${QWT_INCLUDE_DIR}/../bin"
     PATH_SUFFIXES lib bin
     ENV PATH
     DOC "path of the Qwt DLL files to be included in the binary packages"
@@ -109,21 +107,21 @@
     mark_as_advanced(QT_DLL_DIR)
   endif(NOT QT_DLL_DIR STREQUAL "QT_DLL_DIR-NOTFOUND" AND NOT QT_CONFIG MATCHES "static")
 
-  if(NOT QWT5_DLL_DIR STREQUAL "QWT5_DLL_DIR-NOTFOUND")
-    option(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE "Enable this option to include Qwt DLL files in binary packages (default ON)" ON)
-  else(NOT QWT5_DLL_DIR STREQUAL "QWT5_DLL_DIR-NOTFOUND")
-    unset(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE CACHE)
-    set(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE OFF)
-    mark_as_advanced(INCLUDE_QWT5_DLL_IN_BIN_PACKAGE)
-    mark_as_advanced(QWT5_DLL_DIR)
-  endif(NOT QWT5_DLL_DIR STREQUAL "QWT5_DLL_DIR-NOTFOUND")
+  if(NOT QWT_DLL_DIR STREQUAL "QWT_DLL_DIR-NOTFOUND")
+    option(INCLUDE_QWT_DLL_IN_BIN_PACKAGE "Enable this option to include Qwt DLL files in binary packages (default ON)" ON)
+  else(NOT QWT_DLL_DIR STREQUAL "QWT_DLL_DIR-NOTFOUND")
+    unset(INCLUDE_QWT_DLL_IN_BIN_PACKAGE CACHE)
+    set(INCLUDE_QWT_DLL_IN_BIN_PACKAGE OFF)
+    mark_as_advanced(INCLUDE_QWT_DLL_IN_BIN_PACKAGE)
+    mark_as_advanced(QWT_DLL_DIR)
+  endif(NOT QWT_DLL_DIR STREQUAL "QWT_DLL_DIR-NOTFOUND")
 endif()
 
 set(
   LIBS
   ${LIBS} 
   ${QT_LIBRARIES}
-  ${Qwt5_Qt4_LIBRARY}
+  ${QWT_LIBRARIES}
 )
 
 IF(WIN32)
@@ -298,6 +296,11 @@
   ${qtpropertyeditor_SRCS}
   ${qtpropertyeditor_RESOURCES}
   "${BUNDLE_ICON}"
+# qtcreator lacks a proper file management for software based on cmake,
+# this is a workaround to include file within the project tree
+# see also files statements.
+  ${FILES}
+  ${DOXY}
 )
 
 target_link_libraries( qsapecng ${LIBS} )
@@ -325,8 +328,8 @@
     RENAME qsapecng.png
   )
   install(
-    FILES gui/images/qsapecng-24x24.png
-    DESTINATION share/icons/hicolor/24x24/apps
+    FILES gui/images/qsapecng-22x22.png
+    DESTINATION share/icons/hicolor/22x22/apps
     RENAME qsapecng.png
   )
   install(
@@ -351,7 +354,3 @@
   )
   install(
     FILES gui/images/qsapecng-256x256.png
-    DESTINATION share/icons/hicolor/256x256/apps
-    RENAME qsapecng.png
-  )
-  install(

=== debian/changelog ===
qsapecng (2.1.1-1) unstable; urgency=medium

  * New upstream release
  * Fixed "FTBFS: type_traits/detail/has_binary_operator.hp:50: Parse
    error at BOOST_JOIN" upstream (Closes: #834188)
  * Fixed "Segfaults on exit and missing Qt-signals" upstream (Closes: #816898)
  * Bumped Standards-Version to 3.9.8 in debian/control file
  * Removed Georges Khaznadar from Uploaders because he isn't active anymore
  * Removed menu file as stated by the tech-ctte decision on #741573
  * Updated manpage to reflect package description
  * Changed debian/rules to build binaries with debug information for
    dbgsym package

 -- Simone Rossetto <simros85@gmail.com>  Tue, 23 Aug 2016 15:59:56 +0200

qsapecng (2.0.0-8) unstable; urgency=medium

  * Updated debian/watch because upstream moved to GitHub
  * Updated debian/control:
     - changed Homepage (due to GitHub moving)
     - changed url in package description (due to GitHub moving)
  * Updated debian/copyright file with new upstream url

 -- Simone Rossetto <simros85@gmail.com>  Sat, 03 Oct 2015 17:15:43 +0200

qsapecng (2.0.0-7) unstable; urgency=medium

  * Fixed "Please upgrade package for libqwt6abi1 6.1.2" by replacing method
    QwtLog10ScaleEngine with QwtLogScaleEngine (Closes: #798876)
  * Fixed "FTBFS: Parse error at BOOST_JOIN" surrounding any Boost include
    with a '#ifndef Q_MOC_RUN [...] #endif' block as stated here
    https://bugreports.qt.io/browse/QTBUG-22829 (Closes: #799998)
  * Updated doxy.cfg removing obsolete settings

 -- Simone Rossetto <simros85@gmail.com>  Fri, 25 Sep 2015 09:54:57 +0200

qsapecng (2.0.0-6) unstable; urgency=medium

  * Fixed "please make the build reproducible", set HTML_TIMESTAMP=NO
    in file doxy.cfg (Closes: #789428)
  * Updated debian/control:
     - bumped Standards-Version to 3.9.6
     - removed obsolete "DM-Upload-Allowed" field
  * Added absolute path to menu icons in file qsapecng.menu
  * Added relro linker flag to debian/rules file
  * Removed external link to sourceforge donation image in documentation

 -- Simone Rossetto <simros85@gmail.com>  Fri, 26 Jun 2015 18:52:30 +0200

=== debian/control ===
Source: qsapecng
Section: electronics
Priority: optional
Maintainer: Simone Rossetto <simros85@gmail.com>
Build-Depends:
 debhelper (>= 7.0.50~),
 cmake (>= 2.6.0),
 libqt4-dev (>= 4.6.0),
 libqwt-dev (>= 6.1.0),
 libboost-dev (>= 1.41.0),
 doxygen
Standards-Version: 3.9.8
Homepage: https://github.com/skypjack/qsapecng

Package: qsapecng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: qsapecng-doc (= ${binary:Version})
Description: symbolic analyzer and solver of linear analog circuits
 This program consists of two independent parts: the SapecNG framework engine
 and the GUI application QSapecNG.
 .
 QSapecNG is an open source, multi-platform project, continuously enhanced by
 students and researchers of the Department of Electronics and
 Telecommunications (DET) of the University of Florence (Italy). It comes as
 continuation of SapWin for Windows, in order to give to the project a full
 compatibility on other platforms.
 .
 Through SapecNG/QSapecNG users can draw, solve and analyze analog circuits as
 well as manage them. Since version 2.0.0beta1 there is also the full support
 for sub-circuits that can be created, saved, reopened and added as part of
 other circuits.
 .
 SapecNG/QSapecNG is freely available on GitHub
 <https://github.com/skypjack/qsapecng>. A previous version of SapecNG is
 available on GitHub too <https://github.com/skypjack/sapecng>.

Package: qsapecng-doc
Architecture: all
Section: doc
Depends: libjs-jquery, ${misc:Depends}
Recommends: qsapecng (= ${binary:Version})
Suggests: doc-base
Description: symbolic analyzer and solver of linear analog circuits (documentation)
 With QSapecNG users can draw, solve and analyze analog circuits as well as
 manage them. Since version 2.0.0beta1 there is also the full support
 for sub-circuits that can be created, saved, reopened and added as part of
 other circuits.
 .
 This package contains the documentation of QSapecNG.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DH_ALWAYS_EXCLUDE=.git
export DH_OPTIONS


%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_EXE_LINKER_FLAGS="-Wl,-z,relro"
	doxygen doxy.cfg
	rm -f doc/html/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js doc/html/jquery.js

override_dh_auto_clean:
	dh_auto_clean
	rm -fr doc/html doc/latex
	rm -f src/gui/qtsolutions/qtpropertyeditor/moc_*
	rm -f src/gui/qtsolutions/qtpropertyeditor/*.moc

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/qsapecng-$1\.tar\.gz/ \
  https://github.com/skypjack/qsapecng/tags .*/v?(\d\S*)\.tar\.gz
